PFont f;
Background[][] bg;
PImage[] cha = new PImage[8];
PImage attac;

int cols = 13;  
int rows = 13;

int w = 50;
int h = 50;
int nx, ny;

int levelcnt =5;
int level =1;
int ex =0;


String[][] arStage  = {
    {"@","@","@","@","@","@","@","@","@","@","@","@","@"},
    {"@","@","@","@","@","@","@","@","@","@","@","@","@"},
    {"@","@","@","@","@","@","@","@","@","a","@","@","@"},
    {"@","@","@","#","#","#","@","@","@","#","@","@","@"},
    {"@","@","@","#","d","#","@","@","#","#","@","@","@"},
    {"@","e","#","#","#","@","@","@","#","@","@","@","@"},
    {"@","@","#","#","#","@","@","#","#","@","@","@","@"},
    {"@","@","@","#","#","#","@","#","#","@","#","@","@"},
    {"@","@","@","#","#","#","@","#","#","c","#","@","@"},
    {"@","@","@","#","#","#","#","#","#","#","@","@","@"},
    {"@","@","@","@","#","#","#","#","#","@","@","@","@"},
    {"@","@","@","@","b","@","@","@","@","@","@","@","@"},
    {"@","@","@","@","@","@","@","@","@","@","@","@","@"},
 
};

void setup()  {   
  size(750,650);
  smooth();
  
  cha[0] = loadImage("tree.JPG");
  cha[1] = loadImage("back.jpg");
  cha[2] = loadImage("cha1.jpg");
  cha[3] = loadImage("cha2.jpg");
  cha[4] = loadImage("cha3.jpg");
  cha[5] = loadImage("cha4.jpg");
  cha[6] = loadImage("jjh.png");
  cha[7] = loadImage("jjh.jpg");
  attac = loadImage("attac.jpg");
  bg = new Background[cols][rows];
  for (int i= 0; i < 13; i++)
  {
      for (int j = 0; j < 13; j++)
      {
          bg[i][j] = new Background(i*w,j*h,arStage[i][j]);
           
       }
          
   }
  
   f = createFont("Arial",12,true);
}   

void draw()  {   
 background(255,0,0);
 image(cha[6],650,100);
 for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      bg[i][j].display();  
      if (arStage[i][j] == "e")
      {
          nx = i;
          ny = j;
          arStage[i][j] = "#";
      }
    }   
  }
  image(cha[7],nx*w,ny*h);
  mousedrag();
    
  if (levelcnt <= ex) {
    
    
       levelcnt += (level*2);
       level++;
       ex=0;
    }

  textFont(f,14);
  fill(0);
  text("Level: "+level,670,250);
  text("EXP: "+ex,670,270);
  

} 

void mousePressed()  {   
  for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      bg[i][j].click(mouseX,mouseY);  
    }   
  }    
}

void mousedrag()
{
  
 for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      bg[i][j].drag(mouseX,mouseY);  
    }   
  }
}

void keyPressed()
{
  
  int dx =0, dy =0;
  if(key == 'a') 
    dx = -1;
  else if(key == 'd')
    dx = 1;
  else if(key == 'w')
    dy = -1;
  else if(key == 's')
    dy = 1;
if (arStage[ny + dy][nx + dx] != "@")
  {
      
      nx += dx;
      ny += dy;
  }
 
}

